function initRtcBridge()
{
	// Define the callbacks for the asyncRequest
	var callbacks =
	{
		
		success : function (o)
		{

			YAHOO.log("RAW JSON DATA: " + o.responseText);

			// Process the JSON data returned from the server
			var data;
			try
			{
				data = YAHOO.lang.JSON.parse(o.responseText);
			}
			catch (x)
			{
				YAHOO.log("ERROR: JSON Parse failed!");

				// Retry
				setTimeout("initRtcBridge()", 5000);

				return;
			}

			YAHOO.log("PARSED DATA: " + YAHOO.lang.dump(data));
			
			var config = data.ConfigRtcBridge;
			
			setFieldValue('RtcBridge-Field-Mode', config.Mode );
			setFieldChecked('RtcBridge-Field-Input-UseDataForPvt', config.Input.UseDataForPvt);
			setFieldValue('RtcBridge-Field-Input-Port', config.Input.Port);
			
			setFieldValue('RtcBridge-Field-Output-SerialPort', config.Output.SerialPort);
			
			//setConnectionOptions( config.Output.SerialPort );
			enableRadioParameters(config.Output.ConnectionType);
			
			var selectedPort = document.getElementById('RtcBridge-Field-Output-SerialPort');
			var selectedValue = selectedPort.options[selectedPort.selectedIndex].value;
			
			if (selectedValue == "B" || selectedValue == "F") {
				var select = document.getElementById('RtcBridge-Field-Output-BaudRate');
				var children = select.options;

				for (i = 0; i < children.length; i++) {
					if (parseFloat(children[i].innerHTML,10) > 115200) {
						children[i].disabled = true;
						if (i == select.selectedIndex) {
							select.selectedIndex = 0;
						}
					}
				}
			}
			
			setFieldValue('RtcBridge-Field-Output-Connection', config.Output.ConnectionType );
			setFieldValue('RtcBridge-Field-Output-BaudRate', config.Output.BaudRate);
			setFieldValue('RtcBridge-Field-Output-Mode', config.Output.Mode);
			setFieldChecked('RtcBridge-Field-Output-RtsCts', config.Output.RtsCts);
			
			setOutputMode();
			
			// Show form
			showConfigForm();
		},

		failure : function (o)
		{
			if (!YAHOO.util.Connect.isCallInProgress(o))
			{
				YAHOO.log("ERROR: Async call failed!");
			}

			// Retry
			setTimeout("initRtcBridge()", 5000);
		},

		timeout : 10000,
		cache : false
    };
	
	// Make the call to the server for JSON data
	YAHOO.util.Connect.asyncRequest('GET', getConfigRtcBridge, callbacks);

	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Connection', 'change', onRadioTypeChanged);
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-SerialPort', 'change', onSerialPortChanged);
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Mode', 'change', onOutputModeChanged );
	YAHOO.util.Event.addListener( 'RtcBridge-Field-Output-Connection', 'change', onConnectionChanged );
	
	
}

function setOutputMode()
{
	var port = getFieldValue('RtcBridge-Field-Output-SerialPort');
	enableField('RtcBridge-Field-Output-Mode', true );
	if ( port != "A" )
	{
		setFieldValue('RtcBridge-Field-Output-Mode', '232');
		disableField('RtcBridge-Field-Output-Mode');
	}
	
	var mode = getFieldValue('RtcBridge-Field-Output-Mode');
	setFieldVisible('RtcBridge-Field-Output-RtsCts', true);
	if ( mode == "422" )
	{
		setFieldVisible('RtcBridge-Field-Output-RtsCts', false);
	}
}

var serialPortSelect = null;

function onRadioTypeChanged(ev)
{
	var field = YAHOO.util.Event.getTarget(ev);

	enableRadioParameters(field.value);
}

function enableRadioParameters(type)
{
	// Init select managers
	if (serialPortSelect == null) serialPortSelect = new SelectFieldManager( 'RtcBridge-Field-Output-SerialPort');

	// Filter on select fields
	switch (eval(type))
	{
		case 2: // MDL
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', true);
			break;
		case 3: // MGL
			serialPortSelect.setFieldOptions(['A']); // A
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', false);
			break;
		case 4: // PDL
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', true);
			break;
		case 5: // LFE
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', true);
			break;
		case 6: // LFA
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', true);
			break;
		case 7: // ADL Vantage
			serialPortSelect.setFieldOptions(['A','B','F']); // A, B, F
			setFieldValue('RtcBridge-Field-Output-SerialPort','A');
			enableField('RtcBridge-Field-Output-Mode', true);
			break;
		case 8: // ADL Foundation
			serialPortSelect.setFieldOptions(['D']); // D
			setFieldValue('RtcBridge-Field-Output-SerialPort','D');
			enableField('RtcBridge-Field-Output-Mode', false);
			break;
		default:
			break;
	}
}

function onSerialPortChanged( ev )
{
	var field = YAHOO.util.Event.getTarget( ev );
	setOutputMode();
	
	var selectRate = document.getElementById('RtcBridge-Field-Output-BaudRate');
	var children = selectRate.options;
	
	if (field.value == "B" || field.value == "F" || field.value == "D") {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = true;
				if (i == selectRate.selectedIndex) {
					selectRate.selectedIndex = 0;
				}
			}
		}
	} else {
		for (i = 0; i < children.length; i++) {
			if (parseFloat(children[i].innerHTML,10) > 115200) {
				children[i].disabled = false;
			}
		}
	}
}

function onOutputModeChanged( ev )
{
	setOutputMode();
}

function onConnectionChanged( ev )
{
	setFieldValue( 'RtcBridge-Field-Output-Mode', 232 );
	
	var field = YAHOO.util.Event.getTarget( ev );
	if ( field.value == 2 || field.value == 3 )
		setFieldValue( 'RtcBridge-Field-Output-Mode', 422 );
}